uses SystemEx;

type
	PMyMessage=^TMyMessage;
	TMyMessage=object(TMessage)
		C: Char;
	end;
	PTestThread=^TTestThread;
	TTestThread=object(TThread)
		procedure Execute(User: Pointer); virtual;
		procedure GetChar(var Param: TMyMessage); virtual 10;
	end;

procedure TestException(I: Integer);
begin
	if Try then begin    {TRY}
		if I=0 then
			Abort;
		TestException(I-1);
		EndTry;
	end else begin       {EXCEPT}
		Write(I:4);
		Raise;
	end;                 {END}
end;

procedure TTestThread.Execute(User: Pointer);
var
	Pipe: PPipe absolute User;
	S: string;
begin
	repeat
		if Assigned(User) then begin
			WriteLn(Pipe^.O,'Sent by TEST thread');
			while not Pipe^.Empty do begin
				ReadLn(Pipe^.I,S);
				WriteLn('TEST: ',S);
			end;
		end else
			ProcessMessages;
	until Assigned(User) and Keypressed;
	WriteLn('Test selfsuspending.');
	Stop;
	WriteLn('Test selfdestroying.');
end;

procedure TTestThread.GetChar(var Param: TMyMessage);
begin
	Write(Param.C);
end;

var
	Test: PTestThread;
	Pipe: PPipe;
	Msg: PMyMessage;
	S: string;

begin
	WriteLn('SYSTEMEX - TEST APPLICATION');

	{EXCEPTION TEST}
	if Try then begin
		TestException(10);
		EndTry;
	end else begin
		Writeln(' BOOM!');
	end;
	ReadKey;

	{THREADS 1: PIPE, SUPSPEND/ENABLE, SELFDESTROY}
	New(Pipe,Init);
	New(Test,Init('TEST',16000,Pipe));
	repeat
		WriteLn(Pipe^.O,'Sent by MAIN thread');
		while not Pipe^.Empty do begin
			ReadLn(Pipe^.I,S);
			WriteLn('MAIN: ',S);
		end;
		Switch;
	until not Test^.Running;
	Writeln('Test has stopped!');
	ReadKey;
	Test^.Start;
	Writeln('Test Resumed, waiting 1 sec...!');
	Delay(1000);

	{THREADS 2: MESSAGES, REMODE DESTROY}
	WriteLn('Recreating TEST');
	New(Test,Init('TEST',16000,nil));
	WriteLn('Message mode. ESC to quit.');
	repeat
		Msg:=New(PMyMessage,Init);
		with Msg^ do begin
			Message:=10;
			Sender:=self;
			C:=ReadKey;
		end;
		if Msg^.C=#27 then
			Break
		else begin
			Test^.PostMessage(Msg);
		end;
	until False;
	WriteLn('Remote destroying TEST');
	Test^.Free;
	WriteLn('!!! End of Test application !!!');
	ReadKey;
	ClearKeys;
end.